#ifndef __KDOCSAMPLE_H__
#define __KDOCSAMPLE_H__

/**
 * @libdoc A single-class library.
 *
 * This comment is the overall documentation for entire library.
 * It could appear in any one header file.
 * The single class in this library is called @ref KDocSample.
 **/


/**
 * This header file is documented in kdoc format.
 *
 * This is a new paragraph of documentation because it is preceeded by a blank
 * line.  The string "/**" above marks this comment as documentation.
 *
 * If this class created a widget, we might put a small screenshot
 *  here:
 * @image /home/dsweet/KDE/HEAD/kde/share/icons/large/hicolor/apps/go.png
 * @short Sample documented header file
 * @author Joe Developer <jdevel@kde.org>
 * @version 1.0
 */
class KDocSample
{
 public:
  /**
   * @sect Important stuff
   *
   * Instantiate this class.
   * 
   * Notes
   * @li Don't forget to ...
   * @li Be sure to ...
   * @param goodstuff Some good stuff to document.
   * @see getStuff
   **/
  KDocSample (QString goodstuff);

  /**
   * Retrieve the good stuff.
   *
   * @since one two three
   * @returns The good stuff.
   * @exception some_exception some_other_exception
   **/
  virtual QString getStuff () const;
};


#endif
