#ifndef __KDISC_H__
#define __KDISC_H__

#include <qwidget.h>


/**
 * KDisc
 * Lets the user move a disc around with the mouse or keyboard.
 **/
class KDisc : public QWidget
{
 public:
  KDisc (QWidget *parent, const char *name=0);

   protected:
    /**
     * Disc the widget.
     **/
    void paintEvent (QPaintEvent *);
 
    /**
     * Draw the disc under the mouse cursor.
     **/
    void mouseMoveEvent (QMouseEvent *);

    /**
     * Examine the key pressed and move the disc accordingly.
     **/
    void keyPressEvent (QKeyEvent *);

 private:
    QPoint discposition;

};

#endif
