#ifndef __KEDITOR_H__
#define __KEDITOR_H__

#include <ktmainwindow.h>
#include <kurl.h>

class QMultiLineEdit;

class KEditor : public KTMainWindow
{
 Q_OBJECT
 public:
  KEditor (const char *name=0);

 protected slots:
  /**
   * Update the line number field in the statusbar.
   **/
  void slotUpdateStatusBar ();
  /**
   * Open the "Save As" dialog.
   **/
  void slotSaveAs();
  /**
   * Save the file.
   **/
  void slotSave();
  /**
   * Open the "Open" dialog.
   **/
  void slotOpen();

 private:
  QMultiLineEdit *qmle;

  KURL url;
  QString file;
};

#endif

