#ifndef __KLONGJOB_H__
#define __KLONGJOB_H__

#include <ktmainwindow.h>

class QTimer;
class QLabel;
class QPopupMenu;
class KAction;

/**
 * KLongJob
 * Handle a long job while keeping the UI alive.
 **/

class KLongJob : public KTMainWindow
{
 Q_OBJECT

 public:
  KLongJob (const char *name=0);

 private:
  int count, total;
  int idstart, idstop;
  QTimer *qtimer;
  QLabel *qlabel;
  QPopupMenu *file;
  KAction *start, *stop;

 private slots:

   void slotStartComputation ();
   void slotStopComputation ();

  /**
   * Do some of the calculation.
   **/
  void slotComputeSome ();

};

#endif

